main()
{

	maps\mp\_load::main();
	maps\mp\_mp_hud_elem::precache();

	ambientplay ("ambient_dam_int");	

	level._effect["bombexplosion"] = loadfx("fx/explosions/mp_bomb.efx");

	precacheModel("xmodel/light_cagelight_red_on");
	precacheModel("xmodel/light_cagelight_red_off");
	precacheModel("xmodel/fx");

	precachestring(&"RANGESCORE_GETREADY");
	precachestring(&"RANGESCORE_USEREADY");
	precachestring(&"WEAPON_M1A1CARBINE");
	precachestring(&"WEAPON_M1GARAND");
	precachestring(&"WEAPON_KAR98K");
	precachestring(&"WEAPON_LEEENFIELD");
	precachestring(&"WEAPON_MOSINNAGANT");
	precachestring(&"RANGESCORE_ROUNDSTART");
	precachestring(&"RANGESCORE_ROUNDTEXT");

	setCvar("scr_dm_timelimit",0);
	setCvar("scr_tdm_timelimit",0);

	setCvar("scr_killcam", 0);

	game["layoutimage"] = "mp_rifle_range";

	thread shooter_light();

	thread Wait_start();
	thread soundent();
	thread weapons();
	thread roundtimer();
	thread cvar_set();
	thread DoorSound(getent("metal_door","targetname"));

	setup_targets();

	maps\mp\_mp_hud_elem::top_hud();

	level.highscore = 0;


	level.ticker = spawn("script_model",(0,0,0));
	level.ticker setmodel ("xmodel/fx");
	level.ticker hide();
}

shooter_light()
{
	triggers = getentarray ("light_trig","targetname");
	for (i=0;i<triggers.size;i++)
		{
		triggers[i] thread switch_light();
		}
}

roundtimer()
{
	wait 5;

	thread maps\mp\_mp_hud_elem::timer_hud();

	for(;;)
	{

		level waittill("player in booth");

		Announcement(&"RANGESCORE_ROUNDSTART");

		for(tm = 10;tm >= 6;tm--)
		{
			iprintlnbold(tm);

			wait 1;

			iprintlnbold("\n");
		}

		iprintlnbold("");

		Announcement(&"RANGESCORE_GETREADY");

		wait 4;

		level.bestscore = undefined;

		level.roundstart = 1;
		playsound_onplayers("mprr_buzzer");
		level.roundtimer setTimer (300);
		maps\mp\_mp_hud_elem::stopwatch();
		level.ticker playloopsound ("bomb_tick");

		wait 300;

		level.ticker stoploopsound ("bomb_tick");
		playsound_onplayers("mprr_buzzer");
		maps\mp\_mp_hud_elem::kill_stopwatch();
		level.roundstart = undefined;

		if(isdefined(level.highscore) && level.highscore != 0)
		Announcement("^2Game Hightscore: " + level.highscore + " Scored by " + level.highscoreplayer);

		if(isdefined(level.bestscore) && level.bestscore != 0)
		Announcement("^3Round Hightscore: " + level.bestscore + " Scored by " + level.bestscorer);

		wait 10;

	}
}

switch_light()
{

	light = getentarray(self.target,"targetname");
	
	while (1)
	{

		self waittill ("trigger",mp_player);

		hud_gun = player_hud_weapon(mp_player);

		self thread check_player(mp_player);

		if(!isdefined(hud_gun))
			return;

		level notify("player in booth");

		if(!isdefined(mp_player.hudright))
			thread player_huds(self,mp_player,hud_gun);

		if(isdefined(level.roundstart))
		{
			mp_player.hits = 0;
			mp_player.shotsfired = 0;
			mp_player.score = 0;
			mp_player.accuracy = 0;
		}

		while (isdefined(mp_player) && mp_player istouching (self) && isdefined(level.roundstart))
		{
			mp_player giveMaxAmmo(mp_player getcurrentweapon());

			mp_player.scorevalue setValue (mp_player.score);
			mp_player.Shotsvalue setValue (mp_player.shotsfired);
			mp_player.Hitsvalue setValue (mp_player.hits);

			level.top_hud_current_score[self.script_idnumber] setvalue (mp_player.score);

			if((mp_player.hits >= 1) && (mp_player.shotsfired >= 1))
				mp_player.accuracy = ((float)(mp_player.hits * 100) / (mp_player.shotsfired * 100 ) * 100);
			else
				mp_player.accuracy = 0;

			mp_player.accuracyvalue setValue (mp_player.accuracy);

			if(mp_player.score > level.highscore)
			{
				level.highscore = mp_player.score;
				level.highscoreplayer = mp_player.name;
			}

			if(!isdefined(level.bestscore))
			{
				level.bestscore = mp_player.score;
				level.bestscorer = mp_player.name;
			}
			else
			{
				if(mp_player.score > level.bestscore)
				{
					level.bestscore = mp_player.score;
					level.bestscorer = mp_player.name;
				}
			}

			//if(isdefined(mp_player.gun[hud_gun]["bestscore"]))
				//mp_player.highscorevalue setValue (mp_player.gun[hud_gun]["bestscore"]); //(level.highscore);

			if(mp_player.score > 200)
			{
				if(mp_player.score > mp_player.gun[hud_gun]["bestscore"])
				{
					mp_player.gun[hud_gun]["bestscore"] = mp_player.score;

					if(mp_player.gun[hud_gun]["bestscore"] > 400)
						mp_player.gun[hud_gun]["rank"] = 3;
					else
					{
						if(mp_player.gun[hud_gun]["bestscore"] > 300)
							mp_player.gun[hud_gun]["rank"] = 2;
						else
							mp_player.gun[hud_gun]["rank"]= 1;
					}
				}

					text = find_rank(mp_player.gun[hud_gun]["rank"]);

					level.top_hud_rank[self.script_idnumber] settext (text);
					mp_player.playerweaponrank settext (text);

			}

			if(mp_player.score > mp_player.gun[hud_gun]["bestscore"])
					mp_player.gun[hud_gun]["bestscore"] = mp_player.score;

			if(isdefined(mp_player.gun[hud_gun]["bestscore"]))
				mp_player.highscorevalue setValue (mp_player.gun[hud_gun]["bestscore"]); //(level.highscore);

			wait .05;
		}

		for(l=0;l<light.size;l++)
			light[l] setmodel ("xmodel/light_cagelight_red_off");

	wait 1;


		self notify("playergone");

	}

}

check_player(mp_player)
{
	self endon ("playergone");

	check = mp_player getcurrentweapon();

	if((mp_player getweaponslotweapon("primary")) != check)
		gun = "primaryb";
	else
		gun = "primary";

	startammo = mp_player getweaponslotclipammo(gun);

	while(isdefined(mp_player))
	{
		if(mp_player getcurrentweapon() != "none" && isdefined(level.roundstart) && mp_player istouching (self))
		{

			ammo = mp_player getweaponslotclipammo(gun);

			if(ammo < startammo)
			{
				mp_player.shotsfired++;
				startammo = ammo;
			}

			if(ammo > startammo)
				startammo = ammo;
		}

		wait .005;

	}

	self notify("playergone");
}

player_hud_weapon(mp_player)
{

		check = mp_player getcurrentweapon();

		if(check == "none")
			return;

		noloc_gun = noloc_weapon(check);

		if((mp_player getweaponslotweapon("primary")) != check)
			mp_player takeWeapon(mp_player getweaponslotweapon("primary"));
		else
			mp_player takeWeapon(mp_player getweaponslotweapon("primaryb"));

		weaponname = maps\mp\gametypes\_teams::getWeaponName(check);

		if(!isdefined(mp_player.gun))
		{
			mp_player.gun[0]["weaponname"] = weaponname;
			mp_player.gun[0]["noloc_weaponname"] = noloc_gun;
			mp_player.gun[0]["rank"] = 0;
			mp_player.gun[0]["bestscore"] = 0;
			mp_player.gun[0]["qualified"] = 0;
			return(0);
		}
		else
		{
			for(a = 0;a < mp_player.gun.size;a++)
			{
				if(mp_player.gun[a]["weaponname"] == weaponname)

					return(a);
			}

				new = mp_player.gun.size;
				mp_player.gun[new]["weaponname"] = weaponname;
				mp_player.gun[new]["noloc_weaponname"] = noloc_gun;
				mp_player.gun[new]["rank"] = 0;
				mp_player.gun[new]["bestscore"] = 0;
				mp_player.gun[new]["qualified"] = 0;

				return(new);
		}


}

noloc_weapon(oldstring)
{

	newstring = "";

	for(s=0;s<(oldstring.size-3);s++)
	{
		newstring += oldstring[s];
	}

	newstring += "..";
	return newstring;
}

player_huds(trigger,mp_player,hud_gun)
{
	maps\mp\_mp_hud_elem::top_hud_create(trigger.script_idnumber);
	text = find_rank(mp_player.gun[hud_gun]["rank"]);

	level.top_hud_player[trigger.script_idnumber] setvalue (mp_player getEntityNumber());
	level.top_hud_weapon[trigger.script_idnumber] settext(mp_player.gun[hud_gun]["weaponname"]);
	level.top_hud_rank[trigger.script_idnumber] settext (text);
	level.top_hud_current_score[trigger.script_idnumber] setvalue (0);

	mp_player thread maps\mp\_mp_hud_elem::hud(mp_player);
	mp_player.playerweapontext setText(mp_player.gun[hud_gun]["weaponname"]);
	mp_player.playerweaponrank settext (text);
	mp_player.scorevalue setValue (0);

	while (isdefined(mp_player) && mp_player istouching (trigger) && isdefined(level.roundstart))
	wait .05;

	maps\mp\_mp_hud_elem::top_hud_destroy(trigger.script_idnumber);

	if(isdefined(mp_player))
	maps\mp\_mp_hud_elem::hud_destroy(mp_player);

}

playsound_onplayers(sound)
{
	players = getentarray("player", "classname");
	for(i = 0; i < players.size; i++)
	{
			players[i] playLocalSound(sound);
	}
}

playloopsound_onplayers(sound)
{
	players = getentarray("player", "classname");
	for(i = 0; i < players.size; i++)
	{
			players[i] playloopsound(sound);
	}
}
stoploopsound_onplayers(sound)
{
	players = getentarray("player", "classname");
	for(i = 0; i < players.size; i++)
	{
			players[i] stoploopsound(sound);
	}
}

find_rank(rank)
{
	switch(rank)
	{
	case 0: returntext = &"RANGESCORE_NORANK"; break;
	case 1: returntext = &"RANGESCORE_NOVICE"; break;
	case 2: returntext = &"RANGESCORE_ADVANCED"; break;
	case 3: returntext = &"RANGESCORE_EXPERT"; break;

	default: returntext = &"RANGESCORE_NORANK"; break;
	}

	return returntext;
}

find_rank_noloc(rank)
{
	switch(rank)
	{
	case 0: returntext = "^1Unqualified"; break;
	case 1: returntext = "^3Raw Recrute"; break;
	case 2: returntext = "^5Marksman"; break;
	case 3: returntext = "^2Sharpshooter"; break;

	default: returntext = "^1Unqualified"; break;
	}

	return returntext;
}

setup_targets()
{
	scriptorg = getentarray("org1","targetname");
	scriptorg2 = getentarray("org2","targetname");

	for(i = 0; i < scriptorg.size; i++)
		{
		targeted = getent(scriptorg[i].target,"targetname");
		ent = getent(targeted.target,"targetname");
		targeted linkto (scriptorg[i]);
		scriptorg[i] thread move();
		targeted thread follow(ent);
		ent thread target_hit(scriptorg[i]);
		}

	for(i = 0; i < scriptorg2.size; i++)
		{
		targeted = getent(scriptorg2[i].target,"targetname");
		ent = getent(targeted.target,"targetname");
		targeted linkto (scriptorg2[i]);
		scriptorg2[i] thread move2();
		targeted thread follow(ent);
		ent thread target_hit(scriptorg2[i]);
		}
}

target_hit(scriptorg)
{
	while(1)
	{
		self waittill("trigger",other);

		if(isdefined(level.roundstart) && isdefined(other.hudright))
		{
			other.score = (other.score + scriptorg.script_increment);
			scriptorg rotateroll(90,.35);

			wait .1;

			playsound_onplayers("mprr_bullet_large_metal");

			scriptorg waittill("rotatedone");

			wait .2;

			scriptorg rotateroll( -90,.35);
			scriptorg waittill("rotatedone");

			other.hits++;
		}
	}
}

move()
{
while(1)
{
	while (1)
	{
	wait (randomint(8));
	self movex( 1580,(randomint(3)+4));
	self waittill("movedone");
	self movez( 80, 3);
	self waittill("movedone");
	self movex( -1580,(randomint(3)+4));
	self waittill("movedone");
	self movez( -80, 3);
	self waittill("movedone");
	}
wait .05;
}

}

move2()
{
while(1)
{
	while (1)
	{
	wait (randomint(8));
	self movex( -1580,(randomint(3)+4));
	self waittill("movedone");
	self movez( 80, 3);
	self waittill("movedone");
	self movex( 1580,(randomint(3)+4));
	self waittill("movedone");
	self movez( -80, 3);
	self waittill("movedone");
	}
wait .05;
}
}

follow(ent)
{
	while(1)
	{
	ent.origin = self.origin;
	wait (.05);
	}
}

soundent()
{
	radio = spawn("script_model",(-235, -995, -19));
	radio setmodel ("xmodel/fx");
	radio hide();
	radio playloopsound ("mprr_phonograph");
}
cvar_set()
{
	for(;;)
	{
		players = getentarray("player", "classname");

		for(i = 0; i < players.size; i++)
		{

			scorestring = undefined;

			scorestring = "Mapping: BODGER2\n Scripting: BDBODGER";

			if(isdefined(players[i].gun))
			{

				for(g=0;g<players[i].gun.size;g++)
				{

					scorestring += "\n ";

					scorestring += players[i].gun[g]["noloc_weaponname"];

					scorestring +=  "..";

					text = find_rank_noloc(players[i].gun[g]["rank"]);

					scorestring += text;

					scorestring +=  "..";

					scorestring += players[i].gun[g]["bestscore"];

				}

				scorestring += "\nHIGHSCORE";
				scorestring += "..";
				scorestring += level.highscore ;

				if(isdefined(level.highscoreplayer))
				scorestring += " Scored by " + level.highscoreplayer;
			}

			players[i] setClientCvar("cg_objectiveText",scorestring);
		}

		wait 1;
	}
}


DoorSound(door1)
{
    	ang1 = [];
    	ang2 = [];

	dooropen = 0;
	ang1 = door1.angles;
     
		while(1)
		{          
		wait (0.1);

		ang2 = door1.angles;

			if (ang1[1] != ang2[1] )
			{  
				if(dooropen ==0)
				{
					door1 playsound ("mprr_metal_door");               
					wait 1 ;
					ang1 = door1.angles; 
					dooropen = 1; 

				}
				else
				{
					wait 1 ;
					door1 playsound ("mprr_metal_door_stop");
					wait 1 ;
					ang1 = door1.angles; 
					dooropen = 0;
				}           
			}

      		}   
}

weapons()
{
	while(1)
	{
		players = getentarray("player", "classname");

		for(p=0;p<players.size;p++)
		{
			if(!isdefined(players[p].setup))
				players[p] thread Take_pistol_and_grenades();
		}
	wait .5;
	}
}

Take_pistol_and_grenades()
{
	self.setup = 1;

	while(isdefined(self))
	{
		self waittill ("spawned");
		self thread Take_pistol_grenades();
	}
}

Take_pistol_grenades()
{
		self  takeWeapon("colt_mp");
		self  takeWeapon("luger_mp");
		self  takeWeapon("fraggrenade_mp");
		self  takeWeapon("mk1britishfrag_mp");
		self  takeWeapon("rgd-33russianfrag_mp");
		self  takeWeapon("stielhandgranate_mp");

		if(self.sessionteam == "axis")
		{
			self playsound("american_youre_nuts");

			clientAnnouncement(self,"AXIS PLAYERS ARE NOT ALLOWED");

			wait 1;

			origin = self getorigin();
			playfx(level._effect["bombexplosion"], origin);
			self suicide();

			wait 3;

			self playsound("american_area_secure");
		}

		wait .05;
}

Wait_start()
{

while(!isdefined(level.starttime))
wait .05;

	setCvar("ui_allow_thompson", 0);
	setCvar("ui_allow_bar", 0);
	setCvar("ui_allow_springfield", 0);
	setCvar("ui_allow_sten", 0);
	setCvar("ui_allow_bren", 0);
	setCvar("ui_allow_ppsh", 0);
	setCvar("ui_allow_nagantsniper", 0);
	setCvar("ui_allow_mp40", 0);
	setCvar("ui_allow_mp44", 0);
	setCvar("ui_allow_kar98ksniper", 0);
	setCvar("ui_allow_fg42", 0);
	setCvar("ui_allow_panzerfaust", 0);
	setCvar("ui_allow_mg30cal",0);
	setCvar("ui_allow_svt40",0);
	setCvar("ui_allow_dp28",0);
	setCvar("ui_allow_gewehr43",0);
	setCvar("ui_allow_mg34",0);
	setCvar("ui_allow_bazooka",0);
	setCvar("ui_allow_flamethrower",0);
	setCvar("ui_allow_binoculars",0);
	setCvar("ui_allow_artillery",0);
	setCvar("ui_allow_satchel",0);
	setCvar("ui_allow_grenades",0);
	setCvar("ui_allow_smoke",0);
	setCvar("ui_allow_pistols",0);
	setCvar("ui_allow_panzerschreck",0);
	setCvar("ui_allow_artillery",0);

}