precache()
{

	precachestring(&"RANGESCORE_TIMER");

	precachestring(&"RANGESCORE_HIGHSCORE");
	precachestring(&"RANGESCORE_HIGHSCORE2");
	precachestring(&"RANGESCORE_ACCURACY");
	precachestring(&"RANGESCORE_ACCURACY2");
	precachestring(&"RANGESCORE_SCORE");
	precachestring(&"RANGESCORE_SCORE2");
	precachestring(&"RANGESCORE_HITS");
	precachestring(&"RANGESCORE_HITS2");
	precachestring(&"RANGESCORE_SHOTS");
	precachestring(&"RANGESCORE_SHOTS2");
	precachestring(&"RANGESCORE_USEMESSAGE");
	precachestring(&"RANGESCORE_NONE");
	precachestring(&"RANGESCORE_PLAYERSID");
	precachestring(&"RANGESCORE_SCORE3");

	precachestring(&"RANGESCORE_M1A1");
	precachestring(&"RANGESCORE_M1GARAND");
	precachestring(&"RANGESCORE_KAR98");
	precachestring(&"RANGESCORE_LEE_ENFIELD");
	precachestring(&"RANGESCORE_MOSINNAGANT");

	precachestring(&"RANGESCORE_BESTSCORE");
	precachestring(&"RANGESCORE_BESTSCOREVALUE");

	precachestring(&"RANGESCORE_NORANK");
	precachestring(&"RANGESCORE_NOVICE");
	precachestring(&"RANGESCORE_EXPERT");
	precachestring(&"RANGESCORE_ADVANCED");
	precachestring(&"RANGESCORE_GETREADY");
	precachestring(&"RANGESCORE_USEREADY");

	precacheshader("textures/rifle_range/hud@clipboard_lg.dds");
	precacheshader("textures/rifle_range/hud@totals.dds");

	precacheShader("hudStopwatch");
	precacheShader("hudStopwatchNeedle");
}

timer_hud()
{
	level.roundtimer = newHudElem(self);
	level.roundtimer.x = 320;
	level.roundtimer.y = 430;
	level.roundtimer.alignX = "center";
	level.roundtimer.alignY = "middle";
	level.roundtimer.sort = 1;
	level.roundtimer.fontScale = 1.75;
	level.roundtimer setTimer (1);
	level.roundtimer.alpha = 1;
}

stopwatch()
{
	level.stopwatch = newHudElem();
	level.stopwatch.x = 60;
	level.stopwatch.y = 35;
	level.stopwatch.alignX = "center";
	level.stopwatch.alignY = "middle";
	level.stopwatch setClock(600, 60, "hudStopwatch", 64, 64);

}

kill_stopwatch()
{
level.stopwatch destroy();
}

top_hud()
{
	level.top_hud_back = [];
	level.top_hud = [];
	level.top_hud_player = [];
	level.top_hud_weapon = [];
	level.top_hud_rank = [];
	level.top_hud_current_score = [];
	level.top_hud_current_shots =[];
	level.top_hud_current_hits = [];
	level.top_hud_current_accuracy = [];
}


top_hud_create(idnumber)
{


	start = (idnumber * 100);

	topspaceing = 11;
	lspaceing = start+50;
	dspaceing = 11;

		level.top_hud_player[idnumber] = newHudElem();
		level.top_hud_player[idnumber].x = lspaceing;
		level.top_hud_player[idnumber].y = topspaceing;
		level.top_hud_player[idnumber].alignx = "center";
		level.top_hud_player[idnumber].aligny = "middle";
		level.top_hud_player[idnumber].sort = 1;
		level.top_hud_player[idnumber].label = (&"RANGESCORE_PLAYERSID");
		level.top_hud_player[idnumber].fontScale = .7;
		level.top_hud_player[idnumber].alpha = 1;

	topspaceing += dspaceing;

		level.top_hud_weapon[idnumber] = newHudElem();
		level.top_hud_weapon[idnumber].x = lspaceing;
		level.top_hud_weapon[idnumber].y = topspaceing;
		level.top_hud_weapon[idnumber].alignx = "center";
		level.top_hud_weapon[idnumber].aligny = "middle";
		level.top_hud_weapon[idnumber].sort = 1;
		level.top_hud_weapon[idnumber].fontscale = .7;
		level.top_hud_weapon[idnumber].alpha = 1;

	topspaceing += dspaceing;

		level.top_hud_rank[idnumber] = newHudElem();
		level.top_hud_rank[idnumber].x = lspaceing;
		level.top_hud_rank[idnumber].y = topspaceing;
		level.top_hud_rank[idnumber].alignx = "center";
		level.top_hud_rank[idnumber].aligny = "middle";
		level.top_hud_rank[idnumber].sort = 1;
		level.top_hud_rank[idnumber].fontscale = .7;
		level.top_hud_rank[idnumber].alpha = 1;

	topspaceing += dspaceing;

		level.top_hud_current_score[idnumber] = newHudElem();
		level.top_hud_current_score[idnumber].x = lspaceing;
		level.top_hud_current_score[idnumber].y = topspaceing;
		level.top_hud_current_score[idnumber].alignx = "center";
		level.top_hud_current_score[idnumber].aligny = "middle";
		level.top_hud_current_score[idnumber].sort = 1;
		level.top_hud_current_score[idnumber].fontscale = 1;
		level.top_hud_current_score[idnumber].label = (&"RANGESCORE_SCORE3");
		level.top_hud_current_score[idnumber].alpha = 1;
}

top_hud_destroy(idnumber)
{

	level.top_hud_player[idnumber] destroy();
	level.top_hud_weapon[idnumber] destroy();
	level.top_hud_rank[idnumber] destroy();
	level.top_hud_current_score[idnumber] destroy();
}

hud(mp_player)
{
	down = 324;

	mp_player.hudright = newClientHudElem(self);
	mp_player.hudright.x = 512;
	mp_player.hudright.y = down;
	mp_player.hudright.alignX = "left";
	mp_player.hudright.alignY = "top";
	mp_player.hudright.sort = 0;
	mp_player.hudright setShader("textures/rifle_range/hud@totals.dds", 128, 102);
	mp_player.hudright.alpha = 1;

	down += 8;

	mp_player.playerweapontext = newClientHudElem(self);
	mp_player.playerweapontext.x = 576;
	mp_player.playerweapontext.y = down;
	mp_player.playerweapontext.alignX = "center";
	mp_player.playerweapontext.alignY = "top";
	mp_player.playerweapontext.sort = 1;
	mp_player.playerweapontext.fontScale = 1;
	mp_player.playerweapontext.alpha = 1;

	down += 12;

	mp_player.playerweaponrank = newClientHudElem(self);
	mp_player.playerweaponrank.x = 576;
	mp_player.playerweaponrank.y = down;
	mp_player.playerweaponrank.alignX = "center";
	mp_player.playerweaponrank.alignY = "top";
	mp_player.playerweaponrank.sort = 1;
	mp_player.playerweaponrank.fontScale = 1;
	mp_player.playerweaponrank.alpha = 1;
	mp_player.playerweaponrank setText(&"RANGESCORE_NORANK");

	down += 12;

	mp_player.highscorevalue = newClientHudElem(self);
	mp_player.highscorevalue.x = 576;
	mp_player.highscorevalue.y = down;
	mp_player.highscorevalue.alignX = "center";
	mp_player.highscorevalue.alignY = "top";
	mp_player.highscorevalue.sort = 1;
	mp_player.highscorevalue.fontScale = 1;
	mp_player.highscorevalue.alpha = 1;
	mp_player.highscorevalue.label =  (&"RANGESCORE_HIGHSCORE");

	if(isdefined(level.highscore))
		mp_player.highscorevalue setValue (level.highscore);

	down += 12;

	mp_player.scorevalue = newClientHudElem(self);
	mp_player.scorevalue.x = 576;
	mp_player.scorevalue.y = down;
	mp_player.scorevalue.alignX = "center";
	mp_player.scorevalue.alignY = "top";
	mp_player.scorevalue.sort = 1;
	mp_player.scorevalue.fontScale = 1;
	mp_player.scorevalue setValue (self.score);
	mp_player.scorevalue.alpha = 1;
	mp_player.scorevalue.label = (&"RANGESCORE_SCORE") ;

	down += 12;

	mp_player.Shotsvalue = newClientHudElem(self);
	mp_player.Shotsvalue.x = 576;
	mp_player.Shotsvalue.y = down;
	mp_player.Shotsvalue.alignX = "center";
	mp_player.Shotsvalue.alignY = "top";
	mp_player.Shotsvalue.sort = 1;
	mp_player.Shotsvalue.fontScale = 1;
	mp_player.Shotsvalue.alpha = 1;
	mp_player.Shotsvalue.label = (&"RANGESCORE_SHOTS");

	down += 12;

	mp_player.hitsvalue = newClientHudElem(self);
	mp_player.hitsvalue.x = 576;
	mp_player.hitsvalue.y = down;
	mp_player.hitsvalue.alignX = "center";
	mp_player.hitsvalue.alignY = "top";
	mp_player.hitsvalue.sort = 1;
	mp_player.hitsvalue.fontScale = 1;
	mp_player.hitsvalue.alpha = 1;
	mp_player.hitsvalue.label = (&"RANGESCORE_HITS");

	down += 12;

	mp_player.accuracyvalue = newClientHudElem(self);
	mp_player.accuracyvalue.x = 576;
	mp_player.accuracyvalue.y = down;
	mp_player.accuracyvalue.alignX = "center";
	mp_player.accuracyvalue.alignY = "top";
	mp_player.accuracyvalue.sort = 1;
	mp_player.accuracyvalue.fontScale = 1;
	mp_player.accuracyvalue.alpha = 1;
	mp_player.accuracyvalue.label = (&"RANGESCORE_ACCURACY");
}

hud_destroy(mp_player)
{
mp_player.hudright destroy();
mp_player.playerweapontext destroy();
mp_player.playerweaponrank destroy();
mp_player.highscorevalue destroy();
mp_player.scorevalue destroy();
mp_player.Shotsvalue destroy();
mp_player.hitsvalue destroy();
mp_player.accuracyvalue destroy();
}
