precache()
{

	precachestring(&"RANGESCORE_TIMER");

	precachestring(&"RANGESCORE_HIGHSCORE2");
	precachestring(&"RANGESCORE_ACCURACY2");
	precachestring(&"RANGESCORE_SCORE2");
	precachestring(&"RANGESCORE_HITS2");
	precachestring(&"RANGESCORE_SHOTS2");
	precachestring(&"RANGESCORE_USEMESSAGE");
	precachestring(&"RANGESCORE_NONE");

	precachestring(&"RANGESCORE_M1A1");
	precachestring(&"RANGESCORE_M1GARAND");
	precachestring(&"RANGESCORE_KAR98");
	precachestring(&"RANGESCORE_LEE_ENFIELD");
	precachestring(&"RANGESCORE_MOSINNAGANT");

	precachestring(&"RANGESCORE_BESTSCORE");
	precachestring(&"RANGESCORE_BESTSCOREVALUE");

	precachestring(&"RANGESCORE_NORANK");
	precachestring(&"RANGESCORE_NOVICE");
	precachestring(&"RANGESCORE_EXPERT");
	precachestring(&"RANGESCORE_ADVANCED");

	precacheshader("textures/rifle_range/hud@clipboard_lg.dds");

	precacheShader("hudStopwatch");
	precacheShader("hudStopwatchNeedle");
}

timer_hud()
{
	level.minutetext = newHudElem();
	level.minutetext.x = 320;
	level.minutetext.y = 430;
	level.minutetext.alignX = "center";
	level.minutetext.alignY = "top";
	level.minutetext.sort = 1;
	level.minutetext.fontScale = 1.75;
	level.minutetext setTimer (300);
	level.minutetext.alpha = 1;

	level.stopwatch = newHudElem();
	level.stopwatch.x = 60;
	level.stopwatch.y = 60;
	level.stopwatch.alignX = "center";
	level.stopwatch.alignY = "middle";
	level.stopwatch setClock(600, 60, "hudStopwatch", 64, 64);
}

hud()
{
	level.hudright = newHudElem();
	level.hudright.x = 512;
	level.hudright.y = 324;
	level.hudright.alignX = "left";
	level.hudright.alignY = "top";
	level.hudright.sort = 0;
	level.hudright setShader("textures/rifle_range/hud@totals.dds", 128, 102);
	level.hudright.alpha = 1;

	level.playerweapontext = newHudElem();
	level.playerweapontext.x = 576;
	level.playerweapontext.y = 332;
	level.playerweapontext.alignX = "center";
	level.playerweapontext.alignY = "top";
	level.playerweapontext.sort = 1;
	level.playerweapontext.fontScale = 1;
	level.playerweapontext.alpha = 1;

	level.playerweaponrank = newHudElem();
	level.playerweaponrank.x = 576;
	level.playerweaponrank.y = 344;
	level.playerweaponrank.alignX = "center";
	level.playerweaponrank.alignY = "top";
	level.playerweaponrank.sort = 1;
	level.playerweaponrank.fontScale = 1;
	level.playerweaponrank.alpha = 1;

	level.highscorevalue = newHudElem();
	level.highscorevalue.x = 576;
	level.highscorevalue.y = 356;
	level.highscorevalue.alignX = "center";
	level.highscorevalue.alignY = "top";
	level.highscorevalue.sort = 1;
	level.highscorevalue.fontScale = 1;
	level.highscorevalue.alpha = 1;
	level.highscorevalue.label =  (&"RANGESCORE_HIGHSCORE");
	level.highscorevalue setValue (level.highscore);

	level.scorevalue = newHudElem();
	level.scorevalue.x = 576;
	level.scorevalue.y = 368;
	level.scorevalue.alignX = "center";
	level.scorevalue.alignY = "top";
	level.scorevalue.sort = 1;
	level.scorevalue.fontScale = 1;
	level.scorevalue setValue (level.score);
	level.scorevalue.alpha = 1;
	level.scorevalue.label = (&"RANGESCORE_SCORE") ;

	level.Shotsvalue = newHudElem();
	level.Shotsvalue.x = 576;
	level.Shotsvalue.y = 380;
	level.Shotsvalue.alignX = "center";
	level.Shotsvalue.alignY = "top";
	level.Shotsvalue.sort = 1;
	level.Shotsvalue.fontScale = 1;
	level.Shotsvalue.alpha = 1;
	level.Shotsvalue.label = (&"RANGESCORE_SHOTS");

	level.hitsvalue = newHudElem();
	level.hitsvalue.x = 576;
	level.hitsvalue.y = 392;
	level.hitsvalue.alignX = "center";
	level.hitsvalue.alignY = "top";
	level.hitsvalue.sort = 1;
	level.hitsvalue.fontScale = 1;
	level.hitsvalue.alpha = 1;
	level.hitsvalue.label = (&"RANGESCORE_HITS");

	level.accuracyvalue = newHudElem();
	level.accuracyvalue.x = 576;
	level.accuracyvalue.y = 404;
	level.accuracyvalue.alignX = "center";
	level.accuracyvalue.alignY = "top";
	level.accuracyvalue.sort = 1;
	level.accuracyvalue.fontScale = 1;
	level.accuracyvalue.alpha = 1;
	level.accuracyvalue.label = (&"RANGESCORE_ACCURACY");

	while(1)
	{
		gun = level.player getcurrentweapon();

		weapon = 5;

		for(guns = 0;guns < 5;guns++)
		{
			if(gun == level.gun[guns]["name"])
			{
				weapon = guns;

				if(level.gun[guns]["rank"]== "none")
				level.playerweaponrank setText(&"RANGESCORE_NORANK");

				if(level.gun[guns]["rank"]== "NOVICE")
				level.playerweaponrank setText(&"RANGESCORE_NOVICE");

				if(level.gun[guns]["rank"]== "EXPERT")
				level.playerweaponrank setText(&"RANGESCORE_EXPERT");

				if(level.gun[guns]["rank"]== "ADVANCED")
				level.playerweaponrank setText(&"RANGESCORE_ADVANCED");
			}
		}

		switch(weapon)
		{
		case 0: level.playerweapontext setText  (&"RANGESCORE_M1A1");break;
		case 1: level.playerweapontext setText  (&"RANGESCORE_M1GARAND");break;
		case 2: level.playerweapontext setText  (&"RANGESCORE_KAR98");break;
		case 3: level.playerweapontext setText  (&"RANGESCORE_LEE_ENFIELD");break;
		case 4: level.playerweapontext setText  (&"RANGESCORE_MOSINNAGANT");break;
		case 5: level.playerweapontext setText  (&"RANGESCORE_NONE");break;
		}

		wait .05;

	}
}

reporthud()
{

	level.hudshow = 1;

	level.Rtotalback = newHudElem();
	level.Rtotalback.x = 305;
	level.Rtotalback.y = 240;
	level.Rtotalback.alignX = "center";
	level.Rtotalback.alignY = "middle";
	level.Rtotalback.sort = 0;
	level.Rtotalback setShader("textures/rifle_range/hud@clipboard_lg.dds",350, 400);
	level.Rtotalback.alpha = 1;

	level.Rhighscoretext = newHudElem();
	level.Rhighscoretext.x = 180;
	level.Rhighscoretext.y = 120;
	level.Rhighscoretext.alignX = "left";
	level.Rhighscoretext.alignY = "top";
	level.Rhighscoretext.sort = 1;
	level.Rhighscoretext.fontScale = 1.2;
	level.Rhighscoretext.alpha = 1;
	level.Rhighscoretext setText (&"RANGESCORE_HIGHSCORE2");

	level.Rhighscorevalue = newHudElem();
	level.Rhighscorevalue.x = 420;
	level.Rhighscorevalue.y = 120;
	level.Rhighscorevalue.alignX = "right";
	level.Rhighscorevalue.alignY = "top";
	level.Rhighscorevalue.sort = 1;
	level.Rhighscorevalue.fontScale = 1.2;
	level.Rhighscorevalue.alpha = 1;
	level.Rhighscorevalue.label = (&"RANGESCORE_BESTSCOREVALUE");
	level.Rhighscorevalue setValue (level.highscore);

	level.Rscoretext = newHudElem();
	level.Rscoretext.x = 180;
	level.Rscoretext.y = 140;
	level.Rscoretext.alignX = "left";
	level.Rscoretext.alignY = "top";
	level.Rscoretext.sort = 1;
	level.Rscoretext.fontScale = 1.2;
	level.Rscoretext.alpha = 1;
	level.Rscoretext setText (&"RANGESCORE_SCORE2");

	level.Rscorevalue = newHudElem();
	level.Rscorevalue.x = 420;
	level.Rscorevalue.y = 140;
	level.Rscorevalue.alignX = "right";
	level.Rscorevalue.alignY = "top";
	level.Rscorevalue.sort = 1;
	level.Rscorevalue.fontScale = 1.2;
	level.Rscorevalue setValue (level.score);
	level.Rscorevalue.alpha = 1;
	level.Rscorevalue.label = (&"RANGESCORE_BESTSCOREVALUE");

	level.Raccuracytext = newHudElem();
	level.Raccuracytext.x = 180;
	level.Raccuracytext.y = 160;
	level.Raccuracytext.alignX = "left";
	level.Raccuracytext.alignY = "top";
	level.Raccuracytext.sort = 1;
	level.Raccuracytext.fontScale = 1.2;
	level.Raccuracytext.alpha = 1;
	level.Raccuracytext setText (&"RANGESCORE_ACCURACY2");

	level.Raccuracyvalue = newHudElem();
	level.Raccuracyvalue.x = 420;
	level.Raccuracyvalue.y = 160;
	level.Raccuracyvalue.alignX = "right";
	level.Raccuracyvalue.alignY = "top";
	level.Raccuracyvalue.sort = 1;
	level.Raccuracyvalue.fontScale = 1.2;
	level.Raccuracyvalue.alpha = 1;
	level.Raccuracyvalue setValue (level.accuracy);
	level.Raccuracyvalue.label = (&"RANGESCORE_BESTSCOREVALUE");

	level.RShotstext = newHudElem();
	level.RShotstext.x = 180;
	level.RShotstext.y = 180;
	level.RShotstext.alignX = "left";
	level.RShotstext.alignY = "top";
	level.RShotstext.sort = 1;
	level.RShotstext.fontScale = 1.2;
	level.RShotstext.alpha = 1;
	level.RShotstext setText (&"RANGESCORE_SHOTS2");

	level.RShotsvalue = newHudElem();
	level.RShotsvalue.x = 420;
	level.RShotsvalue.y = 180;
	level.RShotsvalue.alignX ="right";
	level.RShotsvalue.alignY = "top";
	level.RShotsvalue.sort = 1;
	level.RShotsvalue.fontScale = 1.2;
	level.RShotsvalue.alpha = 1;
	level.RShotsvalue.label = (&"RANGESCORE_BESTSCOREVALUE");
	level.RShotsvalue setValue (level.shotsfired);

	level.Rhitstext = newHudElem();
	level.Rhitstext.x = 180;
	level.Rhitstext.y = 200;
	level.Rhitstext.alignX = "left";
	level.Rhitstext.alignY = "top";
	level.Rhitstext.sort = 1;
	level.Rhitstext.fontScale = 1.2;
	level.Rhitstext.alpha = 1;
	level.Rhitstext setText (&"RANGESCORE_HITS2");

	level.Rhitsvalue = newHudElem();
	level.Rhitsvalue.x = 420;
	level.Rhitsvalue.y = 200;
	level.Rhitsvalue.alignX = "right";
	level.Rhitsvalue.alignY = "top";
	level.Rhitsvalue.sort = 1;
	level.Rhitsvalue.fontScale = 1.2;
	level.Rhitsvalue.alpha = 1;
	level.Rhitsvalue.label = (&"RANGESCORE_BESTSCOREVALUE");
	level.Rhitsvalue setValue (level.hits);

	yy =220;

	for(r=0;r< 5;r++)
	{
	level.Rweapontext[r] = newHudElem(); 
	level.Rweapontext[r].x = 180;
	level.Rweapontext[r].y = yy;
	level.Rweapontext[r].alignX = "left";
	level.Rweapontext[r].alignY = "top";
	level.Rweapontext[r].sort = 1;
	level.Rweapontext[r].fontScale = 1.2;
	level.Rweapontext[r].alpha = 1;

	level.Rweaponvalue[r] = newHudElem();
	level.Rweaponvalue[r].x = 300;
	level.Rweaponvalue[r].y = yy;
	level.Rweaponvalue[r].alignX = "left";
	level.Rweaponvalue[r].alignY = "top";
	level.Rweaponvalue[r].sort = 1;
	level.Rweaponvalue[r].fontScale = 1.2;
	level.Rweaponvalue[r].alpha = 1;

	level.Rweaponscore[r] = newHudElem();
	level.Rweaponscore[r].x = 420;
	level.Rweaponscore[r].y = yy;
	level.Rweaponscore[r].alignX = "right";
	level.Rweaponscore[r].alignY = "top";
	level.Rweaponscore[r].sort = 1;
	level.Rweaponscore[r].fontScale = 1.2;
	level.Rweaponscore[r].alpha = 1;
	level.Rweaponscore[r].label = (&"RANGESCORE_BESTSCOREVALUE");

	switch(r)
	{
	case 0: level.Rweapontext[r] setText  (&"RANGESCORE_M1A1"); break;
	case 1: level.Rweapontext[r] setText  (&"RANGESCORE_M1GARAND"); break;
	case 2: level.Rweapontext[r] setText  (&"RANGESCORE_KAR98"); break;
	case 3: level.Rweapontext[r] setText  (&"RANGESCORE_LEE_ENFIELD"); break;
	case 4: level.Rweapontext[r] setText  (&"RANGESCORE_MOSINNAGANT"); break;
	}

	yy = yy + 20;

	}

	level.usemessage = newHudElem();
	level.usemessage.x = 200;
	level.usemessage.y = 340;
	level.usemessage.alignX = "left";
	level.usemessage.alignY = "top";
	level.usemessage.sort = 1;
	level.usemessage.fontScale = 1.2;
	level.usemessage.alpha = 1;
	level.usemessage setText (&"RANGESCORE_USEMESSAGE");

	while(!(level.player useButtonPressed()))
	wait .05;

	level.Rtotalback destroy();
	level.Rscoretext destroy();
	level.Rscorevalue destroy();
	level.Raccuracytext destroy();
	level.Raccuracyvalue destroy();
	level.RShotstext destroy();
	level.RShotsvalue destroy();
	level.Rhitstext destroy();
	level.Rhitsvalue destroy();
	level.Rhighscoretext destroy();
	level.Rhighscorevalue destroy();
	level.usemessage destroy();

	for(r=0;r< 5;r++)
	{
	level.Rweapontext[r] destroy();
	level.Rweaponvalue[r] destroy();
	level.Rweaponscore[r] destroy();
	}

	level.hudshow = 0;
}

