main()
{
	maps\_load::main();
	maps\_game::main();
	maps\_hud_elem::precache();

	precacheModel("xmodel/light_cagelight_red_on");
	precacheModel("xmodel/light_cagelight_red_off");

	ambientplay ("ambient_dam_int");
	level.player takeallweapons();

	level.score = 0;
	level.roundrun = 0;
	level.highscore = 0;
	level.accuracy = 0;

	level.gun[0]["name"] = "m1carbine";
	level.gun[1]["name"] = "m1garand";
	level.gun[2]["name"] = "kar98k";
	level.gun[3]["name"] = "enfield";
	level.gun[4]["name"] = "mosin_nagant";

	for(s=0;s < 5;s++)
	{
	level.gun[s]["qualified"] = 0;
	level.gun[s]["rank"] = "none";
	level.gun[s]["bestscore"] = 0;
	}

	thread maps\_hud_elem::hud();

	thread shots();
	thread shooter_light();
	thread soundent();
	thread DoorSound(getent("metal_door","targetname"));

	scriptorg = getentarray("org1","targetname");
	scriptorg2 = getentarray("org2","targetname");

	for(i = 0; i < scriptorg.size; i++)
		{
		targeted = getent(scriptorg[i].target,"targetname");
		ent = getent(targeted.target,"targetname");
		targeted linkto (scriptorg[i]);
		scriptorg[i] thread move();
		targeted thread follow(ent);
		ent thread target_hit(scriptorg[i]);
		}

	for(i = 0; i < scriptorg2.size; i++)
		{
		targeted = getent(scriptorg2[i].target,"targetname");
		ent = getent(targeted.target,"targetname");
		targeted linkto (scriptorg2[i]);
		scriptorg2[i] thread move2();
		targeted thread follow(ent);
		ent thread target_hit(scriptorg2[i]);
		}
}

shooter_light()
{
	triggers = getentarray ("light_trig","targetname");
	for (i=0;i<triggers.size;i++)
		{
		triggers[i] thread switch_light();
		}
}

switch_light()
{
	light = getentarray(self.target,"targetname");
	
	while (1)
	{

	wait 2;

	self waittill ("trigger");

	level.hits = 0;
	level.shotsfired = 0;
	level.score = 0;
	level.scorevalue setValue (0);
	level.accuracy = 0;

	gun = level.player getweaponslotweapon("primary");

	gun2 = level.player getweaponslotweapon("primaryb");

	if(level.player getcurrentweapon() == level.player getweaponslotweapon("primary"))
	{
		level.player takeWeapon(gun2);
		ammoslot = "primary";
	}
	else
	{
		level.player takeWeapon(gun);
		ammoslot = "primaryb";
	}

	if(level.player getcurrentweapon() != "none")
	{

		level.player giveMaxAmmo(level.player getcurrentweapon());

		iprintlnbold ("Use the use key to start round");

		while(!(level.player useButtonPressed()))
		wait .05;

		if(!(level.player istouching(self)))
		continue;

		iprintlnbold ("Get Ready");

		wait 1;

		for(l=0;l<light.size;l++)
		light[l] setmodel ("xmodel/light_cagelight_red_on");

		level.player playsound ("buzzer");
		level.player thread maps\_utility::playLoopSoundOnTag ("bomb_tick",tag_origin );
		level.roundrun = 1;

		maps\_hud_elem::timer_hud();

		level.roundtime = 300;

		while ((level.player istouching (self)) && (level.roundtime > 0 ))
		{
		wait 1;
		level.roundtime--;

		ammo = level.player getweaponslotammo(ammoslot);

		if(ammo == 0)
		level.player giveMaxAmmo(level.player getcurrentweapon());

		level.scorevalue setValue (level.score);
		level.Shotsvalue setValue (level.shotsfired);
		level.Hitsvalue setValue (level.hits);

		if((level.hits >= 1) && (level.shotsfired >= 1))
		level.accuracy = ((float)(level.hits * 100) / (level.shotsfired * 100 ) * 100);

		level.accuracyvalue setValue (level.accuracy);


		if(level.score > level.highscore)
		level.highscore = level.score;

		level.highscorevalue setValue (level.highscore);

		}

		level.player notify ("stop sound" + "bomb_tick");
		level.player playsound ("buzzer");

		thread maps\_hud_elem::reporthud();

		wait .5;

		if(level.score > 200)
		{
			gun = level.player getcurrentweapon();

			for(a = 0;a < 5;a++)
			{
				if(level.gun[a]["name"] == (gun))
				{
					if(level.score > level.gun[a]["bestscore"])
					{
						level.gun[a]["bestscore"] = level.score;

						if(level.gun[a]["bestscore"] > 400)
							level.gun[a]["rank"] = "EXPERT";
						else
						{
							if(level.gun[a]["bestscore"] > 300)
								level.gun[a]["rank"] = "ADVANCED";
							else
								level.gun[a]["rank"]= "NOVICE";
						}
					}
				}
			}
		}


		for(guns = 0;guns < 5;guns++)
		{

			if(level.gun[guns]["rank"]== "none")
			level.Rweaponvalue[guns] setText(&"RANGESCORE_NORANK");

			if(level.gun[guns]["rank"]== "NOVICE")
			level.Rweaponvalue[guns] setText(&"RANGESCORE_NOVICE");

			if(level.gun[guns]["rank"]== "EXPERT")
			level.Rweaponvalue[guns] setText(&"RANGESCORE_EXPERT");

			if(level.gun[guns]["rank"]== "ADVANCED")
			level.Rweaponvalue[guns] setText(&"RANGESCORE_ADVANCED");


			level.Rweaponscore[guns] setValue (level.gun[guns]["bestscore"]);
		}


		for(l=0;l<light.size;l++)
			light[l] setmodel ("xmodel/light_cagelight_red_off");

		level.roundrun = 0;

		level.minutetext destroy();
		level.stopwatch destroy();

		while (level.hudshow ==1)
		wait .05;

		}
	}
}
	
move()
{
	while(1)
	{
		while (level.roundrun == 1)
		{
			wait (randomint(8));
			self movex( 1580,(randomint(3)+4));
			self waittill("movedone");
			self movez( 80, 3);
			self waittill("movedone");
			self movex( -1580,(randomint(3)+4));
			self waittill("movedone");
			self movez( -80, 3);
			self waittill("movedone");
		}
	wait .05;
	}

}

move2()
{
	while(1)
	{
		while (level.roundrun == 1)
		{
			wait (randomint(8));
			self movex( -1580,(randomint(3)+4));
			self waittill("movedone");
			self movez( 80, 3);
			self waittill("movedone");
			self movex( 1580,(randomint(3)+4));
			self waittill("movedone");
			self movez( -80, 3);
			self waittill("movedone");
		}
	wait .05;
	}
}

follow(ent)
{
	while(1)
	{
	ent.origin = self.origin;
	wait (.05);
	}
}

target_hit(scriptorg)
{
	while(1)
	{
		self waittill("trigger");

		if(level.roundrun == 1)
		{
			level.score = (level.score + scriptorg.script_increment);
			scriptorg rotateroll(90,.35);

			wait .1;

			level.player playsound ("bullet_large_metal");
			scriptorg waittill("rotatedone");

			wait .2;

			scriptorg rotateroll( -90,.35);
			scriptorg waittill("rotatedone");

			level.hits++;
		}
	}
}

shots()
{
	trigger = getent("shotcounter","targetname");

	while(1)
	{
		trigger waittill("trigger");

		if (level.roundrun == 1)
			level.shotsfired++;
	}
}

soundent()
{
	ent = getent("sounder","targetname");
	ent playloopsound ("phonograph");
}


DoorSound(door1)
{
    	ang1 = [];
    	ang2 = [];

	dooropen = 0;
	ang1 = door1.angles;

	while(1)
	{          
	wait (0.1);

	ang2 = door1.angles;

		if (ang1[1] != ang2[1] )
		{  
			if(dooropen ==0)
			{
				door1 playsound ("metal_door");               
				wait 1 ;
				ang1 = door1.angles; 
				dooropen = 1; 
			}

			else
			{
				door1 playsound ("metal_door_close");
				wait 1 ;
				door1 playsound ("metal_door_stop");
				wait 1 ;
				ang1 = door1.angles; 
				dooropen = 0;
			}           
		}

      	}    
}
